package lecture;

public class IntListList
{
    private IntList carValue;
    private IntListList cdrValue;
    private boolean isEmpty;

    private IntListList() {
    	isEmpty = true;
    }
    
    private IntListList(IntList i, IntListList rest) {
    	isEmpty = false;
    	carValue = i;
    	cdrValue = rest;
    }
    
    private IntListList(IntList [] elements) {
    	if (elements.length == 0) {
    	   isEmpty = true;
    	} else {
    		isEmpty = false;
    		IntListList rest = new IntListList();
    		for (int i= elements.length - 1; i >= 1; i--) {
    			rest = new IntListList(elements[i],rest);
    		}
    		carValue = elements[0];
    		cdrValue = rest;
       }
    }
    
    public String toString() {
    	if (isEmpty) {
    		return "[]";
    	} else {
    		return "[" + carValue + "," + cdrValue.toString() + "]";
    	} 	
    }
    
    public static IntListList cons(IntList i, IntListList list) {
    	return new IntListList(i,list);
    }
    public static IntListList intList(IntList [] elements) { return new IntListList(elements); }
    public static IntListList nil = new IntListList();
    public static IntList car(IntListList list){ return list.carValue; }
    public static IntListList cdr(IntListList list){ return list.cdrValue; }
    public static boolean isNil(IntListList list) { return list.isEmpty; }
    public static void print(IntListList list) { System.out.println(list); return; }
 
}
